#include "TestHaikuWindow.h"
//------------------------------------------------------------------------------
// BeOS
#include <Application.h>
#include <Menu.h>
#include <MenuItem.h>
// C++
#include <string>
// Add2
// Proj
#include "Common.h"
#include "Constants.h"
#include "LKKConstants.h"
#include "TestHaikuView.h"
//------------------------------------------------------------------------------
#define	_T(x)	(x)
#define	acc_label(x, y)	(string(y))
#define	FUC_ELLIPSIS	string("...")
//==============================================================================
TTestHaikuWindow::TTestHaikuWindow(BRect oFrame)
		: SUPER(oFrame, (gAppNameEnUs), B_TITLED_WINDOW, B_ASYNCHRONOUS_CONTROLS)
{
	SetWinTitle();
	// メニューと主ビューの作成
	mMBar = new BMenuBar(BRect(0, 0, 0, 0), "MenuBar");
	AddChild(mMBar);
	oFrame.OffsetTo(B_ORIGIN);
	oFrame.top += mMBar->Frame().Height()+1;
	mTestHaikuView = new TTestHaikuView(oFrame);
	AddChild(mTestHaikuView);
	CreateMenu();
	// Filter
//	DBEXP("TTestHaikuWindow::TTestHaikuWindow()", "creating filter...");
//	AddCommonFilter(new TMouseDownFilter());
}
//------------------------------------------------------------------------------
TTestHaikuWindow::~TTestHaikuWindow()
{
}
//------------------------------------------------------------------------------
void	TTestHaikuWindow::CreateMenu()
{
	BMenu*			aMenu;
	BMenuItem*		aMItem;

	// ファイル
	aMenu = new BMenu(acc_label("F", _T(LKK_MENU_FILE)).c_str());
		// 新規作成
		aMItem = new BMenuItem(acc_label("N", _T(LKK_MITEM_NEW)).c_str(), new BMessage((uint32)0), 'N');
//		aMItem->SetTarget();
		aMenu->AddItem(aMItem);
		aMenu->AddSeparatorItem();
		// 終了
		aMItem = new BMenuItem(acc_label("Q", _T(LKK_MITEM_QUIT)).c_str(), new BMessage(B_QUIT_REQUESTED), 'Q');
		aMenu->AddItem(aMItem);
	mMBar->AddItem(aMenu);
	// ツール
	aMenu = new BMenu(acc_label("T", _T(LKK_MENU_TOOL)).c_str());
		// ＳＨＩＮＴＡ共通環境設定
		aMItem = new BMenuItem(acc_label("S", _T(LKK_MITEM_SHINTA_COMMON_PREFS)+FUC_ELLIPSIS).c_str(), new BMessage('hoge'));
		aMenu->AddItem(aMItem);
		aMenu->SetTargetForItems(be_app);
	mMBar->AddItem(aMenu);
	// ヘルプ
	aMenu = new BMenu(acc_label("H", _T(LKK_MENU_HELP)).c_str());
		// バージョン情報
		aMItem = new BMenuItem(acc_label("A", _T(LKK_MITEM_ABOUT)+FUC_ELLIPSIS).c_str(), new BMessage(B_ABOUT_REQUESTED));
		aMenu->AddItem(aMItem);
		aMenu->SetTargetForItems(be_app);
	mMBar->AddItem(aMenu);
}
//------------------------------------------------------------------------------
void	TTestHaikuWindow::DestroyMenu()
{
	BMenu*	aMenu;

	while  ( (aMenu = mMBar->SubmenuAt(0)) != NULL ) {
		mMBar->RemoveItem(aMenu);
		delete aMenu;
	}
}
//------------------------------------------------------------------------------
void	TTestHaikuWindow::MessageReceived(BMessage* oMsg)
{
	switch( oMsg->what ) {
	case B_MOUSE_DOWN:
		MouseDown(oMsg);
		break;
	default:
		SUPER::MessageReceived(oMsg);
	}
}
//------------------------------------------------------------------------------
void	TTestHaikuWindow::MouseDown(BMessage* oMsg)
{
	BPoint	aPoint;

	oMsg->FindPoint("where", &aPoint);
//	DBEXP("TTestHaikuWindow::MouseDown() - where", BRect(aPoint, B_ORIGIN));
	oMsg->FindPoint("be:view_where", &aPoint);
//	DBEXP("TTestHaikuWindow::MouseDown() - be:view_where", BRect(aPoint, B_ORIGIN));
}
//------------------------------------------------------------------------------
void	TTestHaikuWindow::Quit()
{
	SUPER::Quit();
}
//------------------------------------------------------------------------------
bool	TTestHaikuWindow::QuitRequested()
{
	be_app_messenger.SendMessage(B_QUIT_REQUESTED);
	return SUPER::QuitRequested();
}
//------------------------------------------------------------------------------
void	TTestHaikuWindow::SetWinTitle()
{
	SetTitle(_T(gAppNameEnUs));
#ifdef DEBUG
	SetTitle((string("［デバッグ］ ")+Title()).c_str());
#endif
}
//------------------------------------------------------------------------------
//==============================================================================
TMouseDownFilter::TMouseDownFilter()
		: SUPER(B_MOUSE_DOWN)
{
//	DBEXP("TMouseDownFilter::TMouseDownFilter()", "");
}
//------------------------------------------------------------------------------
filter_result	TMouseDownFilter::Filter(BMessage* oMsg, BHandler** oTgt)
{
//	DBEXP("TMouseDownFilter::Filter()", "");
	*oTgt = Looper();
//	*oTgt = be_app;	// NG
	return B_DISPATCH_MESSAGE;
}
//------------------------------------------------------------------------------
//==============================================================================
